# Changelog

Das Format dieser Datei basiert auf [Keep a Changelog](https://keepachangelog.com/de).

Das hier veröffentlichte Changelog bezieht sich auf die [Testinstanz von FIT-Connect](https://docs.fitko.de/fit-connect/docs/getting-started/get-started#testing).

## 2022-08-22

### Dokumentation

- Die Startseite wurde geändert.
- Inhalte, die bislang auf der Startseite zu finden waren, sind nun in den neuen Seiten "Anträge senden" und "Anträge empfangen" vorhanden, unterhalb des Menüpunkts "FIT-Connect nutzen". 
- Der Menüpunkt "Infos für Verantwortliche" wurde eingeführt, mit den neuen Seiten "Fachverfahren anbinden", Onlinedienste/Softwareprogramme anbinden" und "Zertifikate beantragen".

## 2022-08-18

### Dokumentation

- Der Menüpunkt "Grundlagen" wurde umbenannt in "Infos für Entwickler:innen".
- Die Menüpunkte "Versand von Einreichung" und "Abruf von Einreichungen" befinden sich jetzt unterhalb des Menüpunkts "Grundlagen für Entwickler:innen".

## 2022-07-26

### Zustelldienst 1.8.1

- Fix: Eine erfolgreiche Prüfung der Signatur von Zustellpunkten ohne Antwortkanäle (`replyChannels`) war nicht möglich. Dies wurde behoben. Alle alten Signaturen wurden erneut berechnet und im DVDV aktualisiert. ([Story](https://git.fitko.de/fit-connect/planning/-/issues/487))
- Fix: Unter bestimmten Umständen war es möglich einen Anhang doppelt mit gleicher `attachmentId` zu hinterlegen.

## 2022-06-29

### Zustelldienst 1.6.1

- Anfertigen von Statistiken von Submissions (Fachdaten) und deren Anhängen. ([Story](https://git.fitko.de/fit-connect/planning/-/issues/272))


## 2022-06-14

### Zustelldienst 1.5.15

- Prüfung der in Zustellpunkten hinterlegten Zertifikate (JWK). ([Story](https://git.fitko.de/fit-connect/planning/-/issues/119))
  Fehler in der Zertifikatskette werden vorerst nur geloggt.

## 2022-06-02

### Self Service Portal 1.3.7
- Fix: Es war möglich, sich über das Self-Service-Portal Zugriff auf fremde Destinations zu verschaffen
<!-- https://git.fitko.de/fit-connect/planning/-/issues/449 -->

### Zustelldienst 1.5.14

- Fix: SQL Fehler in DB Migration bzgl. Jobrunr

### Zustelldienst 1.5.13

- Benachrichtigung des technischen Ansprechpartners bei nicht-erfolgtem Abruf durch Subscriber - Szenario 1. ([Story](https://git.fitko.de/fit-connect/planning/-/issues/304))
- Benachrichtigung des technischen Ansprechpartners bei nicht-erfolgtem Abruf durch Subscriber - Szenario 2. ([Story](https://git.fitko.de/fit-connect/planning/-/issues/372))
- Umsetzung korrekter HTTP Header wie Content-Security-Policy ([Story](https://git.fitko.de/fit-connect/planning/-/issues/308)) sowie X-Frame-Options und X-XSS-Protection ([Story](https://git.fitko.de/fit-connect/planning/-/issues/309)).

## 2022-05-03
### Dokumentation
- Dokumentation zu [Benachrichtigungen und Löschfristen](getting-started/notifications-and-deletion-deadlines.mdx) ergänzt.

### Zustelldienst 1.5.12
- Automatisches Abweisen von Einreichungen, wenn diese mehr als 14 Tage im Status 'submitted' bleiben.
  ([Story](https://git.fitko.de/fit-connect/planning/-/issues/283))
- Automatisches Löschen von Einreichungen im Zustand 'incomplete' (nach 1 Tag), 'accepted' und 'rejected' (nach 7 Tagen).
  Gelöscht werden dabei Metainformationen und Anhänge der Einreichungen; ein entsprechender Eintrag wird im Ereignisprotokoll erzeugt.
  ([Story](https://git.fitko.de/fit-connect/planning/-/issues/91))

## 2022-04-27
### Dokumentation
- [Beschreibung der Betriebsumgebungen](getting-started/get-started.mdx#environments) ergänzt

## 2022-04-21
### Zustelldienst 1.5.11
- Löschen der Zustellpunkte im DVDV wenn diese im Zustelldienst gelöscht werden.
  ([Story](https://git.fitko.de/fit-connect/planning/-/issues/369))

## 2022-04-14
### Zustelldienst 1.5.10
- Fix: Das erste Anlegen eines SET Events (Submit Submission, Reject Submission etc.) nach dem (Neu)Start der Software erfolgt nun korrekt.
  ([Bug](https://git.fitko.de/fit-connect/planning/-/issues/393))
  - Dies ist ein Follow-up Fix für diesen [Bug](https://git.fitko.de/fit-connect/planning/-/issues/366), welcher das Problem
    in allen Fällen bis auf den ersten nach dem Software Neustart behoben hat.

## 2022-04-07
### Self Service Portal 1.3.6
- Fix: Der News Link im Header des SSP wurde bis auf Weiteres entfernt.
  ([Bug](https://git.fitko.de/fit-connect/planning/-/issues/370))
- Fix: Zustellpunkte, die mit einem Client verlinkt sind, können nun auch korrekt im SSP gelöscht werden. Vorher wurde
  der Zustellpunkt teilweise nur im Zustelldienst gelöscht. Dies führte dazu, dass im SSP Zustellpunkte - die schon
  gelöscht waren - noch z.B. in der Client Edit Form zur Auswahl angezeigt wurden.
  ([Bug](https://git.fitko.de/fit-connect/planning/-/issues/379))

### Zustelldienst 1.5.9
- Fix: Beim Anlegen einer Einreichung für eine spezielle caseId wird nun korrekt überprüft, ob diese CaseId überhaupt existiert.
  ([Bug](https://git.fitko.de/fit-connect/planning/-/issues/306))
- Fix: An den DVDV wurden falsch formatierte Werte für `alg` und `keyOp` übergeben ([Commit](https://git.fitko.de/fit-connect/zustelldienst/-/commit/ad3621d5addfddb3b11a2c100cb27fec279ee1fd), [Commit](https://git.fitko.de/fit-connect/zustelldienst/-/commit/b3d5df127a8f08ef8ebdf9cf5688c3d1b75a736b))

## 2022-04-01
### Dokumentation
- Dokumentation zur Sicherstellung der Integrität des Gesamtantrags für [sendende](sending/metadata.mdx#integrity) und [empfangende Systeme](receiving/verification.mdx#integrity).

## 2022-03-28
### Zustelldienst 1.5.6
- Signed Event Tokens werden jetzt auch korrekt angenommen, wenn der "issued at" (iat) Claim 5 Minuten in der Zukunft
  liegt. Dies ist hilfreich, wenn das ausstellende System kleine Abweichungen in der Systemzeit im Vergleich zur
  Zustelldienst-Systemzeit hat.
  ([Bug](https://git.fitko.de/fit-connect/planning/-/issues/362))
- Der Zustelldienst kann jetzt alle zulässigen Signed Event Token Payload Schemas prüfen, ohne dafür zur Laufzeit einen
  Download durchzuführen. Bis jetzt gab es Probleme, wenn der Zustelldienst nur über einen Proxy
  auf das Internet zugreifen kann. Gleichzeitig ist es jetzt möglich das Signed Event Token Payload Schema in der
  Version [1.0.0](https://schema.fitko.de/fit-connect/set-payload/1.0.0/set-payload.schema.json) sowie weiterhin
  [0.1.0](https://schema.fitko.de/fit-connect/set-payload/0.1.0/set-payload.schema.json) zu verwenden.
  ([Bug](https://git.fitko.de/fit-connect/planning/-/issues/366))

## 2022-03-24
### Zustelldienst 1.5.4
- Es wurde ein Bug behoben bei dem konfigurierte ausgehende Proxies nicht verwendet wurden.

### Zustelldienst 1.5.3
- Zugriff auf Einreichungen und Anlagen überarbeitet. Ein Empfänger sieht nur noch Einreichungen und deren Anlagen im Status Submitted oder Forwarded je nach API Endpunkt.
  ([Bug](https://git.fitko.de/fit-connect/planning/-/issues/25))

### SET Payload Schema 1.0.0
- Das [SET Payload Schema 1.0.0](https://schema.fitko.de/fit-connect/set-payload/1.0.0/set-payload.schema.json) wurde
  veröffentlicht. Inhaltlich entspricht es dem [SET Payload Schema 0.1.0](https://schema.fitko.de/fit-connect/set-payload/0.1.0/set-payload.schema.json).
  Beide Versionen sollen bis auf Weiteres unterstützt werden, jedoch planen wir schon die Version `0.1.0` zeitnah zu
  deprecated.

## 2022-03-21
### Zustelldienst 1.5.0, 1.5.1
- Zuordnung von Public Keys zu Destinations wird hergestellt. Achtung: Hierbei handelt es sich um einen Breaking Change,
  bei dem die Zustelldienstdatenbank inclusiver aller Zustellpunkte, Einreichungen, Ereignisse und Public Keys gelöscht
  werden
  ([Story](https://git.fitko.de/fit-connect/planning/-/issues/288))
- `SQL Fehler bei der Wiederverwendung von Schlüsseln` behoben. Nun können Public Keys für mehrere Zustellpunkte
  gleichzeitig verwendet werden.
  ([Bug](https://git.fitko.de/fit-connect/planning/-/issues/264))
- Bug `Aktualisierter Schlüssel wird nicht hinterlegt` behoben
  ([Bug](https://git.fitko.de/fit-connect/planning/-/issues/251))
- API-Version wurde auf `1.0.7` geändert. (Keine Technischen Veränderungen)

### Zustelldienst 1.4.1
- `DVDV Anbindungs URL Validierung Fehler` behoben
  ([Story](https://git.fitko.de/fit-connect/planning/-/issues/146))

### Zustelldienst 1.4.0
- Anbindung des DVDV. Damit der Routingdienst Informationen über einen Zustellpunkt beim DVDV abfragen kann, wurde eine
  Anbindung des Zustelldienstes an die DVDV-API zur Übertragung von technischen Parametern der Zustellpunkte
  (Verschlüsselungszertifikat, Fachdatenschema, etc.) umgesetzt.
  ([Story](https://git.fitko.de/fit-connect/planning/-/issues/146))

## 2022-03-17
### Self Service Portal 1.3.4
- Bug `Aktualisierter Schlüssel wird nicht hinterlegt` behoben
  ([Bug](https://git.fitko.de/fit-connect/planning/-/issues/251))
- Bug `Destinations können nicht aktiviert werden` behoben
  ([Bug](https://git.fitko.de/fit-connect/planning/-/issues/363))

## 2022-03-10
### Zustelldienst OAuth Token Validator 1.0.1
- Beheben eines Authentikations-Problems bei dem valide OAuth Tokens nicht akzeptiert wurden.

### Self Service Portal 1.3.3
- Bug `Aktualisierter Schlüssel wird nicht hinterlegt` behoben
 ([Bug](https://git.fitko.de/fit-connect/planning/-/issues/251))
  - Leider fehlerhaft und verursachte ([Bug](https://git.fitko.de/fit-connect/planning/-/issues/363))

### Self Service Portal 1.3.2
- Security Feature: Das Self Service Portal wird über einen Docker Container ausgeliefert. Dieser Docker Container nutzt
  nun einen "non-root" Nutzer für den Betrieb der Software um die Angriffsoberfläche zu reduzieren und die Sicherheit zu
  erhöhen.
  ([Story](https://git.fitko.de/fit-connect/planning/-/issues/44))

### Zustelldienst 1.3.3
- Feature: Die Zustellung von `Callbacks` wird wiederholt sollange diese nicht erfolgreich versendet werden können. Mehr
  dazu finden Sie [hier](https://docs.fitko.de/fit-connect/docs/sending/accept-reject/)
  ([Story](https://git.fitko.de/fit-connect/planning/-/issues/76))

### Zustelldienst 1.3.2
- Bugfix für den `Die erste Einreichung schlägt fehl` Fehler
  ([Bug](https://git.fitko.de/fit-connect/planning/-/issues/303))

### Zustelldienst 1.3.1
- Die Reihenfolge der Ereignisse im Ereignis-Log für einen Einreichungsvorgang wurde von "Aufsteigend basiert auf der
  Ereignis Id und gruppiert basierend auf der Einreichungsid" zu "Aufsteigend basiert auf der Ereignis Id" geändert
  ([Bug](https://git.fitko.de/fit-connect/planning/-/issues/279))
- Security Feature: Der Zustelldienst wird über einen Docker Container ausgeliefert. Dieser Docker Container nutzt
  nun einen "non-root" Nutzer für den Betrieb der Software um die Angriffsoberfläche zu reduzieren und die Sicherheit zu
  erhöhen.
  ([Story](https://git.fitko.de/fit-connect/planning/-/issues/44))
- `SQL Fehler bei der Wiederverwendung von Schlüsseln` durch eine bessere Fehlermeldung addressiert.
  ([Bug](https://git.fitko.de/fit-connect/planning/-/issues/264))
- Es wurde ein Fehler behoben, bei dem in seltenen Fällen kurzzeitig eine unterschieddliche Anzahl an absoluten
  Einreichungen und verfügbaren Einreichungen im selben Auflistungs Request bestand. Das gleiche Problem wurde für die
  Auflistung an Zustellpunkten und Einreichungsvorgang Ereignis-Log Einträgen behoben.

### Dokumentation
- Erlaubte Schlüsselverwendungen in den [Vorgaben für kryptographische Verfahren](./details/crypto.md) ergänzt.

### API Spezifikation 1.0.7
- Dokumentation zu Event Logs verbessert
- Nutzungsbedingungen verlinkt

## 2022-03-08
### Dokumentation
- Informationen zur wiederholten Zustellung von Callbacks in den Artikeln [Vorhandensein neuer Einreichungen prüfen](./receiving/notification.mdx) und [Empfangsbestätigung oder Zurückweisung](./sending/accept-reject.mdx)

## 2022-03-07
### Dokumentation
- [Anleitung zur Nutzung der FIT-Connect CLI-Tools](./details/jwk-creation.md) aktualisiert

## 2022-03-01
### Dokumentation
- [Code-Beispiele zum Verschlüsseln von Daten](./sending/encrypt.mdx) gemäß den [Vorgaben für krytographischen Verfahren](./details/crypto.md) angepasst (Korrektur JWE-Header-Attribute).

## 2022-02-22
### Zustelldienst 1.3.0
- Story: Prüfung von Events im Zustelldienst:
  Die Liste der Prüfungen, denen Security Event Token unterzogen werden, wurde erweitert.
  ([Story](https://git.fitko.de/fit-connect/planning/-/issues/297))

### Dokumentation
- [Fehlertyp `security-event-token-validation`](./status-and-error-codes.md#fachliche-fehler) dokumentiert.

### API Spezifikation 1.0.6
- Statuscode 422 für die Endpunkte `POST /v1/submissions` und `POST /v1/cases/{caseId}/events` dokumentiert.

## 2022-02-07
### Dokumentation
- Hinweise zur [Signaturprüfung der vom DVDV gelieferten Zustellpunkt-Parameter](./responsibilities/get-destination.mdx#checkDestinationParametersSignature) ergänzt

## 2022-02-03
### Zustelldienst 1.2.0
- Story: Der Zustelldienst schreibt nun zusätzliche Infos in die Events `submit-submission` und `notify-submission`.
  Die Events enthalten jetzt eine Referenz (`$schema`) auf das zugehörige Schema.
  ([Story](https://git.fitko.de/fit-connect/planning/-/issues/210))

### Dokumentation
- Die [Beschreibung des Ereignisprotokolls](getting-started/event-log/overview.mdx) wurde in mehrere Seiten aufgeteilt.
- Die [Liste der Ereignisse](getting-started/event-log/events.mdx) wurde um die Beschreibung der Payloads erweitert.
- Umgang mit [Empfangsbestätigung oder Zurückweisung](sending/accept-reject.mdx) ergänzt.
- [Einreichung überprüfen](receiving/verification.mdx) ergänzt.

## 2022-01-19
### Dokumenation
- [Aufbau der Zustellpunkt-Informationen](responsibilities/get-destination.mdx#destination-object) überarbeitet

## 2022-01-17
### Dokumentation
- [Kontaktmöglichkeiten](/contact) überarbeitet

##  2022-01-11
### Dokumentation
- [Abschnitt zur Pflege der FIT-Connect „destinationSignatur“ in FIM-Redaktionssytemen](responsibilities/routing.mdx) ergänzt

### Self Service Portal 1.3.1
- Fix: Anpassung des Address Export und Zustelldienst Signature Typs um dem JWT Standard besser gerecht zu werden (`JWT` statt `jwt`)

### Self Service Portal 1.3.0
- Story: Das Self-Service-Portal stellt jetzt unter `/v1/delivery-services` eine JWS mit den Hostnamen aller Zustelldienste bereit
  ([Story](https://git.fitko.de/fit-connect/planning/-/issues/172))

##  2021-12-14

### API Spezifikation 1.0.5
- Der Content-Type für das Senden von Events wurde korrigiert.

## 2021-12-10

### Self Service Portal 1.2.2
- Bugfixes für: Statusmodell einer Destination
  ([Story](https://git.fitko.de/fit-connect/planning/-/issues/18))

### Zustelldienst 1.1.1
- Bugfixes für: Statusmodell einer Destination
  ([Story](https://git.fitko.de/fit-connect/planning/-/issues/18))
- Callback-Aufrufe können nun über einen Proxy geleitet werden.
  ([Story](https://git.fitko.de/fit-connect/planning/-/issues/298))
- API-Version in `1.0.4` geändert.

##  2021-12-02

### Self Service Portal 1.2.1
- Bugfix: Aktualisierung von Services über das Self-Service-Portal ist nicht möglich
  ([Bug](https://git.fitko.de/fit-connect/planning/-/issues/282))

##  2021-12-01

### API Spezifikation 1.0.4
- Es wurden kaputte Links in der API-Spezifikation korrigiert.

### Self Service Portal 1.2.0
- Story: Zugang zur Produktivumgebung auf Basis von Gruppenzugehörigkeit
  ([Story](https://git.fitko.de/fit-connect/planning/-/issues/6))

##  2021-11-29

### Self Service Portal 1.1.0 / 1.1.1
- Story: Export von Zustellpunkt Adressierungsinformationen als JWS
  ([Story](https://git.fitko.de/fit-connect/planning/-/issues/175))

##  2021-11-23

### Zustelldienst 1.0.3
- Bugfix: Nicht-erfolgreiche Callback-Aufrufe dürfen nicht zu einem Fehler führen.
  ([Bug](https://git.fitko.de/fit-connect/planning/-/issues/207))
- API-Version in `1.0.3` geändert.

##  2021-11-18

### Self Service Portal 1.0.2
- Bugfix: Alle Links zur Dokumentations auf der Zustellpunkt Erstell und Bearbeiten Seite von der Version ´next´ zu ´v1´ geändert.
- Bugfix: Der Link zur Urn Verwaltungsleistung Suche auf der Zustellpunkt Erstell und Bearbeiten Seite wurde korrigiert

##  2021-11-17

### Zustelldienst 1.0.2
- Bugfix: Es wurde der Inhalt des `type` Felds gefixt, der bei der Callback-Übermittelung an einen Zustellpunkt verwendet wird.
  ([Story](https://git.fitko.de/fit-connect/planning/-/issues/233))
- Bugfix: Der Endpunkt `POST /v1/submissions/{submissionId}` wurde gemäß der aktuellen API-Spezifikation nach `POST /v1/cases/{caseId}` verlegt.
  ([Story](https://git.fitko.de/fit-connect/planning/-/issues/244))

## 2021-11-15

### API Spezifikation 1.0.3

- Der Wert `created` für den Status wurde aus dem `PATCH`-Endpunkt entfernt. ([Bug](https://git.fitko.de/fit-connect/planning/-/issues/238))

Die Version 1.0.2 wurde zurückgezogen und durch 1.0.3 ersetzt. Version 1.0.3 ist gleichwertig zu 1.0.1

## 2021-11-11

### API Spezifikation 1.0.1

- Die Callback URIs wurden korrigiert, so dass sie jetzt die `submission-api` enthalten.

##  2021-11-10
### Metadata Schema 1.0.0
  - [Version 1.0.0](https://schema.fitko.de/fit-connect/metadata/1.0.0/) wurde released

### Self Service Portal 1.0.1
  - Die auswählbare unterstütze Metadaten Version `0.9.6` bei Zustellpunkten wurde deprecated und entfernt. Sie wird durch die neu releaste [Version 1.0.0](https://schema.fitko.de/fit-connect/metadata/1.0.0/) ersetzt.
    ([Story](https://git.fitko.de/fit-connect/planning/-/issues/232))

### Zustelldienst 1.0.1
- Die auswählbare unterstütze Metadaten Version `0.9.6` bei Zustellpunkten wurde deprecated und entfernt.
  Sie wird durch die neu releaste [Version 1.0.0](https://schema.fitko.de/fit-connect/metadata/1.0.0/) ersetzt.
  Alle bestenden Zustellpunkte werden automatisch von Version `0.9.6` auf `1.0.0` migriert.
  ([Story](https://git.fitko.de/fit-connect/planning/-/issues/232))
- Bugfix: Es wurde gefixt, dass bei einer erfolgreichen Einreichung nicht mehr der Sender, sondern der Empfänger über den Callback benachrichtig wird.
  ([Story](https://git.fitko.de/fit-connect/planning/-/issues/234))

## Submission API [1.0.0] - 2021-11-05

:::caution
Diese Version beinhaltet **breaking changes** für bestehende Nutzer der Beta 6 und Beta 7 der Submission API
:::

Mit der Version 1.0.0 der Submission API wurden grundlegende Änderungen am Verschlüsselungskonzept und Statusmodell durchgeführt. Zudem wurden viele Endpunkte nicht abwärtskompatibel überarbeitet.

Für bestehende Nutzer der Beta 6 und Beta 7 wird daher dringend empfohlen, sich vollständig mit der Dokumentation der API V1 auseinanderzusetzen, um ein Upgrade auf die neue Version der Submission API zu planen.

Sollten dennoch Fragen zur Migration auf die V1 offen bleiben, können Sie sich an das Service Desk wenden: [fit-connect-support ät fjd.de](mailto:fit-connect-support@fjd.de)
